=== external/schaapcommon/src/fft/test/CMakeLists.txt ===
# Copyright (C) 2020 ASTRON (Netherlands Institute for Radio Astronomy)
# SPDX-License-Identifier: GPL-3.0-or-later

include(${SCHAAPCOMMON_SOURCE_DIR}/cmake/unittest.cmake)

add_unittest(fft runtests.cc tconvolution.cc tresampler.cc trestoreimage.cc)
