=== debian/changelog ===
wsclean (3.1-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + wsclean-dev: Add Multi-Arch: same.

  [ Ole Streicher ]
  * Push Standards-Version to 4.6.2, no changes needed
  * Use system provided pybind11

 -- Ole Streicher <olebole@debian.org>  Thu, 05 Jan 2023 12:54:39 +0100

wsclean (3.1-2) unstable; urgency=medium

  * Link libatomic against wsclean-lib on riscv64 and fix FTBFS
    (Closes: #1018157)

 -- Ole Streicher <olebole@debian.org>  Sat, 27 Aug 2022 18:43:24 +0200

wsclean (3.1-1) unstable; urgency=medium

  * New upstream version 3.1
  * Rediff patches
  * Update build dependencies
  * Push Standards-Version to 4.6.1. No changes needed

 -- Ole Streicher <olebole@debian.org>  Tue, 24 May 2022 15:46:46 +0200
