=== debian/control ===
Source: wsclean
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>,
           Ole Streicher <olebole@debian.org>
Section: science
Priority: optional
Build-Depends: casacore-dev,
               cmake,
               debhelper-compat (= 13),
               libblas-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcfitsio-dev,
               libfftw3-dev,
               libgsl-dev,
               libhdf5-dev,
               liblapack-dev,
               python3-pybind11,
               python3-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/wsclean
Vcs-Git: https://salsa.debian.org/debian-astro-team/wsclean.git
Homepage: https://gitlab.com/aroffringa/wsclean/
Rules-Requires-Root: no

Package: wsclean
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: wsclean-dev
Description: Fast generic widefield interferometric imager
 WSClean (w-stacking clean) is a fast generic widefield imager. It uses the
 w-stacking algorithm and can make use of the w-snapshot algorithm. As of
 Feb 2014, it is 2-12 times faster than CASA's w-projection, depending on the
 array configuration. It supports full-sky imaging and proper beam correction
 for homogeneous dipole arrays such as the MWA.
 .
 WSClean allows Hogbom and Cotton-Schwab cleaning, and can clean polarizations
 joinedly. All operations are performed on the CPU (it is not specialized for
 GPUs).

Package: wsclean-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: wsclean
Multi-Arch: same
Description: Fast generic widefield interferometric imager (development files)
 WSClean (w-stacking clean) is a fast generic widefield imager. It uses the
 w-stacking algorithm and can make use of the w-snapshot algorithm. As of
 Feb 2014, it is 2-12 times faster than CASA's w-projection, depending on the
 array configuration. It supports full-sky imaging and proper beam correction
 for homogeneous dipole arrays such as the MWA.
 .
 WSClean allows Hogbom and Cotton-Schwab cleaning, and can clean polarizations
 joinedly. All operations are performed on the CPU (it is not specialized for
 GPUs).
 .
 This package contains the static library and the header file to
 compile own programs against the library.
